# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from smarthome_light_msgs/LightingStateData.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import smarthome_msgs.msg
import sensor_msgs.msg
import smarthome_light_msgs.msg
import std_msgs.msg

class LightingStateData(genpy.Message):
  _md5sum = "b8f9b6ddbbcbd913409d347e9efdd67e"
  _type = "smarthome_light_msgs/LightingStateData"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """## State data light message

Header header                         # timestamp is the time the illuminance was measured
                                      # frame_id is the location and direction of the reading

smarthome_msgs/NodeState state        # State

sensor_msgs/Illuminance illuminance   # Measurement of the photometric illuminance in Lux

geometry_msgs/Pose pose	              # A representation of pose in free space, composed of postion and orientation. 

smarthome_light_msgs/Hsb hsb          # Hue/Saturation/Brightness values of the light

smarthome_msgs/DeviceInfo descriptor  # Hardware information

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: smarthome_msgs/NodeState
## State of smarthome node

int8 val

# State status constants
int8 ERROR=-1   # Error
int8 UNKNOWN=0  # Unknown or unavailable
int8 INIT=1     # Intialize/starting process
int8 ENABLE=2
int8 SHUTDOWN=3

================================================================================
MSG: sensor_msgs/Illuminance
 # Single photometric illuminance measurement.  Light should be assumed to be
 # measured along the sensor's x-axis (the area of detection is the y-z plane).
 # The illuminance should have a 0 or positive value and be received with
 # the sensor's +X axis pointing toward the light source.

 # Photometric illuminance is the measure of the human eye's sensitivity of the
 # intensity of light encountering or passing through a surface.

 # All other Photometric and Radiometric measurements should
 # not use this message.
 # This message cannot represent:
 # Luminous intensity (candela/light source output)
 # Luminance (nits/light output per area)
 # Irradiance (watt/area), etc.

 Header header           # timestamp is the time the illuminance was measured
                         # frame_id is the location and direction of the reading

 float64 illuminance     # Measurement of the Photometric Illuminance in Lux.

 float64 variance        # 0 is interpreted as variance unknown
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: smarthome_light_msgs/Hsb
# Actor HSB
uint32 brightness               # Brightness of the light
uint32 saturation		# Saturation of the light
uint32 hue                      # Color of the light


================================================================================
MSG: smarthome_msgs/DeviceInfo
# Device info captures device agnostic information about a piece of hardware.
# This message is meant as a generic as possible.  Items that don't apply should
# be left blank.  This message is not meant to replace diagnostic messages, but
# rather provide a standard service message that can be used to populate standard
# components (like a GUI for example)
# Base on industrial_msgs/DeviceInfo.msg


string manufacturer             # Manufacturer
string model                    # Model number
string serial_number            # Serial number
string hw_version               # Hardware version
string sw_version               # Software version
string address                  # 
"""
  __slots__ = ['header','state','illuminance','pose','hsb','descriptor']
  _slot_types = ['std_msgs/Header','smarthome_msgs/NodeState','sensor_msgs/Illuminance','geometry_msgs/Pose','smarthome_light_msgs/Hsb','smarthome_msgs/DeviceInfo']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,state,illuminance,pose,hsb,descriptor

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LightingStateData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.state is None:
        self.state = smarthome_msgs.msg.NodeState()
      if self.illuminance is None:
        self.illuminance = sensor_msgs.msg.Illuminance()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.hsb is None:
        self.hsb = smarthome_light_msgs.msg.Hsb()
      if self.descriptor is None:
        self.descriptor = smarthome_msgs.msg.DeviceInfo()
    else:
      self.header = std_msgs.msg.Header()
      self.state = smarthome_msgs.msg.NodeState()
      self.illuminance = sensor_msgs.msg.Illuminance()
      self.pose = geometry_msgs.msg.Pose()
      self.hsb = smarthome_light_msgs.msg.Hsb()
      self.descriptor = smarthome_msgs.msg.DeviceInfo()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_b3I.pack(_x.state.val, _x.illuminance.header.seq, _x.illuminance.header.stamp.secs, _x.illuminance.header.stamp.nsecs))
      _x = self.illuminance.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_9d3I.pack(_x.illuminance.illuminance, _x.illuminance.variance, _x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.hsb.brightness, _x.hsb.saturation, _x.hsb.hue))
      _x = self.descriptor.manufacturer
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.descriptor.model
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.descriptor.serial_number
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.descriptor.hw_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.descriptor.sw_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.descriptor.address
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.state is None:
        self.state = smarthome_msgs.msg.NodeState()
      if self.illuminance is None:
        self.illuminance = sensor_msgs.msg.Illuminance()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.hsb is None:
        self.hsb = smarthome_light_msgs.msg.Hsb()
      if self.descriptor is None:
        self.descriptor = smarthome_msgs.msg.DeviceInfo()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.state.val, _x.illuminance.header.seq, _x.illuminance.header.stamp.secs, _x.illuminance.header.stamp.nsecs,) = _struct_b3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.illuminance.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.illuminance.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 84
      (_x.illuminance.illuminance, _x.illuminance.variance, _x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.hsb.brightness, _x.hsb.saturation, _x.hsb.hue,) = _struct_9d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.manufacturer = str[start:end].decode('utf-8')
      else:
        self.descriptor.manufacturer = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.model = str[start:end].decode('utf-8')
      else:
        self.descriptor.model = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.serial_number = str[start:end].decode('utf-8')
      else:
        self.descriptor.serial_number = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.hw_version = str[start:end].decode('utf-8')
      else:
        self.descriptor.hw_version = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.sw_version = str[start:end].decode('utf-8')
      else:
        self.descriptor.sw_version = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.address = str[start:end].decode('utf-8')
      else:
        self.descriptor.address = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_b3I.pack(_x.state.val, _x.illuminance.header.seq, _x.illuminance.header.stamp.secs, _x.illuminance.header.stamp.nsecs))
      _x = self.illuminance.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_9d3I.pack(_x.illuminance.illuminance, _x.illuminance.variance, _x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.hsb.brightness, _x.hsb.saturation, _x.hsb.hue))
      _x = self.descriptor.manufacturer
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.descriptor.model
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.descriptor.serial_number
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.descriptor.hw_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.descriptor.sw_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.descriptor.address
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.state is None:
        self.state = smarthome_msgs.msg.NodeState()
      if self.illuminance is None:
        self.illuminance = sensor_msgs.msg.Illuminance()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.hsb is None:
        self.hsb = smarthome_light_msgs.msg.Hsb()
      if self.descriptor is None:
        self.descriptor = smarthome_msgs.msg.DeviceInfo()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.state.val, _x.illuminance.header.seq, _x.illuminance.header.stamp.secs, _x.illuminance.header.stamp.nsecs,) = _struct_b3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.illuminance.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.illuminance.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 84
      (_x.illuminance.illuminance, _x.illuminance.variance, _x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.hsb.brightness, _x.hsb.saturation, _x.hsb.hue,) = _struct_9d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.manufacturer = str[start:end].decode('utf-8')
      else:
        self.descriptor.manufacturer = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.model = str[start:end].decode('utf-8')
      else:
        self.descriptor.model = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.serial_number = str[start:end].decode('utf-8')
      else:
        self.descriptor.serial_number = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.hw_version = str[start:end].decode('utf-8')
      else:
        self.descriptor.hw_version = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.sw_version = str[start:end].decode('utf-8')
      else:
        self.descriptor.sw_version = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.descriptor.address = str[start:end].decode('utf-8')
      else:
        self.descriptor.address = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_b3I = struct.Struct("<b3I")
_struct_9d3I = struct.Struct("<9d3I")
